'use strict';

exports.__esModule = true;

var _pick2 = require('lodash/pick');

var _pick3 = _interopRequireDefault(_pick2);

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _remove2 = require('lodash/remove');

var _remove3 = _interopRequireDefault(_remove2);

var _trim2 = require('lodash/trim');

var _trim3 = _interopRequireDefault(_trim2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _clone2 = require('lodash/clone');

var _clone3 = _interopRequireDefault(_clone2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _OverlayTrigger = require('rsuite-utils/lib/Overlay/OverlayTrigger');

var _OverlayTrigger2 = _interopRequireDefault(_OverlayTrigger);

var _Picker = require('rsuite-utils/lib/Picker');

var _utils = require('rsuite-utils/lib/utils');

var _utils2 = require('../utils');

var _DropdownMenu = require('../_picker/DropdownMenu');

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

var _DropdownMenuCheckItem = require('../_picker/DropdownMenuCheckItem');

var _DropdownMenuCheckItem2 = _interopRequireDefault(_DropdownMenuCheckItem);

var _PickerToggle = require('../_picker/PickerToggle');

var _PickerToggle2 = _interopRequireDefault(_PickerToggle);

var _getToggleWrapperClassName = require('../_picker/getToggleWrapperClassName');

var _getToggleWrapperClassName2 = _interopRequireDefault(_getToggleWrapperClassName);

var _TypeDefinition = require('../utils/TypeDefinition');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var value = props.value,
        defaultValue = props.defaultValue,
        groupBy = props.groupBy,
        valueKey = props.valueKey,
        labelKey = props.labelKey;

    var nextValue = (0, _clone3.default)(value || defaultValue) || [];

    _this.state = {
      value: nextValue,
      // Used to hover the active item  when trigger `onKeydown`
      focusItemValue: nextValue ? nextValue[0] : undefined,
      searchKeyword: ''
    };

    if (groupBy === valueKey || groupBy === labelKey) {
      throw Error('`groupBy` can not be equal to `valueKey` and `labelKey`');
    }
    return _this;
  }

  Dropdown.prototype.getValue = function getValue() {
    var value = this.props.value;

    var nextValue = (0, _isUndefined3.default)(value) ? this.state.value : value;
    return (0, _clone3.default)(nextValue) || [];
  };

  /**
   * Index of keyword  in `label`
   * @param {node} label
   */


  Dropdown.prototype.shouldDisplay = function shouldDisplay(label) {
    var searchKeyword = this.state.searchKeyword;

    if (!(0, _trim3.default)(searchKeyword)) {
      return true;
    }

    var keyword = searchKeyword.toLocaleLowerCase();

    if (typeof label === 'string' || typeof label === 'number') {
      return ('' + label).toLocaleLowerCase().indexOf(keyword) >= 0;
    } else if (React.isValidElement(label)) {
      var nodes = (0, _utils.reactToString)(label);
      return nodes.join('').toLocaleLowerCase().indexOf(keyword) >= 0;
    }
    return false;
  };

  Dropdown.prototype.findNode = function findNode(focus) {
    var items = this.getFocusableMenuItems();
    var valueKey = this.props.valueKey;
    var focusItemValue = this.state.focusItemValue;


    for (var i = 0; i < items.length; i += 1) {
      if ((0, _utils.shallowEqual)(focusItemValue, items[i][valueKey])) {
        focus(items, i);
        return;
      }
    }

    focus(items, -1);
  };

  Dropdown.prototype.focusNextMenuItem = function focusNextMenuItem() {
    var _this2 = this;

    var valueKey = this.props.valueKey;

    this.findNode(function (items, index) {
      var focusItem = items[index + 1];
      if (!(0, _isUndefined3.default)(focusItem)) {
        _this2.setState({ focusItemValue: focusItem[valueKey] });
      }
    });
  };

  Dropdown.prototype.focusPrevMenuItem = function focusPrevMenuItem() {
    var _this3 = this;

    var valueKey = this.props.valueKey;

    this.findNode(function (items, index) {
      var focusItem = items[index - 1];
      if (!(0, _isUndefined3.default)(focusItem)) {
        _this3.setState({ focusItemValue: focusItem[valueKey] });
      }
    });
  };

  Dropdown.prototype.selectFocusMenuItem = function selectFocusMenuItem(event) {
    var _this4 = this;

    var value = this.getValue();
    var _props = this.props,
        data = _props.data,
        valueKey = _props.valueKey;
    var focusItemValue = this.state.focusItemValue;


    if (!focusItemValue) {
      return;
    }

    if (!value.some(function (v) {
      return (0, _utils.shallowEqual)(v, focusItemValue);
    })) {
      value.push(focusItemValue);
    } else {
      (0, _remove3.default)(value, function (itemVal) {
        return (0, _utils.shallowEqual)(itemVal, focusItemValue);
      });
    }

    var focusItem = data.find(function (item) {
      return (0, _utils.shallowEqual)((0, _get3.default)(item, valueKey), focusItemValue);
    });

    this.setState({ value: value }, function () {
      _this4.handleSelect(value, focusItem, event);
      _this4.handleChangeValue(value, event);
    });
  };

  Dropdown.prototype.renderDropdownMenu = function renderDropdownMenu() {
    var _this5 = this;

    var _props2 = this.props,
        data = _props2.data,
        labelKey = _props2.labelKey,
        groupBy = _props2.groupBy,
        searchable = _props2.searchable,
        renderExtraFooter = _props2.renderExtraFooter,
        locale = _props2.locale,
        placement = _props2.placement,
        renderMenu = _props2.renderMenu,
        menuClassName = _props2.menuClassName,
        menuStyle = _props2.menuStyle;
    var focusItemValue = this.state.focusItemValue;

    var classes = (0, _classnames2.default)(this.addPrefix('check-menu'), this.addPrefix('placement-' + (0, _kebabCase3.default)(placement)), menuClassName);
    var filteredData = (0, _utils.filterNodesOfTree)(data, function (item) {
      return _this5.shouldDisplay(item[labelKey]);
    });

    // Create a tree structure data when set `groupBy`
    if (groupBy) {
      filteredData = (0, _utils.getDataGroupBy)(filteredData, groupBy);
    }

    var menuProps = (0, _pick3.default)(this.props, _DropdownMenu2.default.handledProps.filter(function (name) {
      return !['className', 'style', 'classPrefix'].some(function (item) {
        return item === name;
      });
    }));

    var menu = React.createElement(_DropdownMenu2.default, _extends({}, menuProps, {
      style: menuStyle,
      classPrefix: this.addPrefix('check-menu'),
      dropdownMenuItemClassPrefix: this.addPrefix('check-menu-item'),
      dropdownMenuItemComponentClass: _DropdownMenuCheckItem2.default,
      ref: this.bindMenuContainerRef,
      activeItemValues: this.getValue(),
      focusItemValue: focusItemValue,
      data: filteredData,
      group: !(0, _isUndefined3.default)(groupBy),
      onSelect: this.handleItemSelect
    }));

    return React.createElement(
      _Picker.MenuWrapper,
      { className: classes, onKeyDown: this.handleKeyDown },
      searchable && React.createElement(_Picker.SearchBar, {
        placeholder: locale.searchPlaceholder,
        onChange: this.handleSearch,
        value: this.state.searchKeyword
      }),
      renderMenu ? renderMenu(menu) : menu,
      renderExtraFooter && renderExtraFooter()
    );
  };

  Dropdown.prototype.render = function render() {
    var _props3 = this.props,
        data = _props3.data,
        valueKey = _props3.valueKey,
        labelKey = _props3.labelKey,
        className = _props3.className,
        placeholder = _props3.placeholder,
        renderValue = _props3.renderValue,
        disabled = _props3.disabled,
        cleanable = _props3.cleanable,
        locale = _props3.locale,
        classPrefix = _props3.classPrefix,
        onOpen = _props3.onOpen,
        onClose = _props3.onClose,
        placement = _props3.placement,
        open = _props3.open,
        defaultOpen = _props3.defaultOpen,
        toggleComponentClass = _props3.toggleComponentClass,
        block = _props3.block,
        style = _props3.style,
        container = _props3.container,
        containerPadding = _props3.containerPadding,
        onEnter = _props3.onEnter,
        onEntering = _props3.onEntering,
        onEntered = _props3.onEntered,
        onExit = _props3.onExit,
        onExiting = _props3.onExiting,
        onExited = _props3.onExited,
        appearance = _props3.appearance,
        rest = _objectWithoutProperties(_props3, ['data', 'valueKey', 'labelKey', 'className', 'placeholder', 'renderValue', 'disabled', 'cleanable', 'locale', 'classPrefix', 'onOpen', 'onClose', 'placement', 'open', 'defaultOpen', 'toggleComponentClass', 'block', 'style', 'container', 'containerPadding', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited', 'appearance']);

    var unhandled = (0, _utils2.getUnhandledProps)(Dropdown, rest);
    var value = this.getValue();
    var selectedItems = !!value && !!value.length ? data.filter(function (item) {
      return value.some(function (val) {
        return (0, _utils.shallowEqual)(item[valueKey], val);
      });
    }) : [];
    var hasValue = !!selectedItems.length;

    var selectedLabel = hasValue ? (0, _utils.tplTransform)(locale.selectedValues, selectedItems.length) : placeholder;
    if (renderValue && hasValue) {
      selectedLabel = renderValue(value, selectedItems);
    }

    var classes = (0, _getToggleWrapperClassName2.default)('check', this.addPrefix, this.props, hasValue);

    return React.createElement(
      _OverlayTrigger2.default,
      {
        ref: this.bindTriggerRef,
        open: open,
        defaultOpen: defaultOpen,
        disabled: disabled,
        trigger: 'click',
        placement: placement,
        onEnter: onEnter,
        onEntering: onEntering,
        onEntered: (0, _utils2.createChainedFunction)(this.handleOpen, onEntered),
        onExit: onExit,
        onExiting: onExiting,
        onExited: (0, _utils2.createChainedFunction)(this.handleExited, onExited),
        speaker: this.renderDropdownMenu(),
        container: container,
        containerPadding: containerPadding
      },
      React.createElement(
        'div',
        {
          className: classes,
          style: style,
          onKeyDown: this.handleKeyDown,
          tabIndex: -1,
          role: 'menu',
          ref: this.bindContainerRef
        },
        React.createElement(
          _PickerToggle2.default,
          _extends({}, unhandled, {
            componentClass: toggleComponentClass,
            onClean: this.handleClean,
            cleanable: cleanable && !disabled,
            hasValue: hasValue
          }),
          selectedLabel || locale.placeholder
        )
      )
    );
  };

  return Dropdown;
}(React.Component);

Dropdown.defaultProps = {
  appearance: 'default',
  data: [],
  disabledItemValues: [],
  maxHeight: 320,
  valueKey: 'value',
  labelKey: 'label',
  locale: {
    placeholder: 'Select',
    searchPlaceholder: 'Search',
    selectedValues: '{0} selected'
  },
  searchable: true,
  cleanable: true,
  placement: 'bottomLeft'
};
Dropdown.handledProps = ['appearance', 'block', 'className', 'classPrefix', 'cleanable', 'container', 'containerPadding', 'data', 'defaultOpen', 'defaultValue', 'disabled', 'disabledItemValues', 'groupBy', 'labelKey', 'locale', 'maxHeight', 'menuClassName', 'menuStyle', 'onChange', 'onClose', 'onEnter', 'onEntered', 'onEntering', 'onExit', 'onExited', 'onExiting', 'onGroupTitleClick', 'onOpen', 'onSearch', 'onSelect', 'open', 'placeholder', 'placement', 'renderExtraFooter', 'renderMenu', 'renderMenuGroup', 'renderMenuItem', 'renderValue', 'searchable', 'style', 'toggleComponentClass', 'value', 'valueKey'];
Dropdown.propTypes = {
  appearance: _propTypes2.default.oneOf(['default', 'subtle']).isRequired,
  data: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  locale: _propTypes2.default.object.isRequired,
  classPrefix: _propTypes2.default.string,
  className: _propTypes2.default.string,
  container: _propTypes2.default.oneOfType([function () {
    return (typeof HTMLElement === 'function' ? _propTypes2.default.instanceOf(HTMLElement) : _propTypes2.default.any).apply(this, arguments);
  }, _propTypes2.default.func]),
  containerPadding: _propTypes2.default.number,
  block: _propTypes2.default.bool,
  toggleComponentClass: function toggleComponentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType) : _propTypes2.default.any).apply(this, arguments);
  },
  menuClassName: _propTypes2.default.string,
  menuStyle: _propTypes2.default.object,
  disabled: _propTypes2.default.bool,
  disabledItemValues: _propTypes2.default.arrayOf(_propTypes2.default.any),
  maxHeight: _propTypes2.default.number,
  valueKey: _propTypes2.default.string,
  labelKey: _propTypes2.default.string,
  value: _propTypes2.default.arrayOf(_propTypes2.default.any),
  defaultValue: _propTypes2.default.arrayOf(_propTypes2.default.any),
  renderMenu: _propTypes2.default.func,
  renderMenuItem: _propTypes2.default.func,
  renderMenuGroup: _propTypes2.default.func,
  renderValue: _propTypes2.default.func,
  renderExtraFooter: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  onGroupTitleClick: _propTypes2.default.func,
  onSearch: _propTypes2.default.func,
  onOpen: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onEnter: _propTypes2.default.func,
  onEntering: _propTypes2.default.func,
  onEntered: _propTypes2.default.func,
  onExit: _propTypes2.default.func,
  onExiting: _propTypes2.default.func,
  onExited: _propTypes2.default.func,

  /**
   * group by key in `data`
   */
  groupBy: _propTypes2.default.any,
  placeholder: _propTypes2.default.node,
  searchable: _propTypes2.default.bool,
  cleanable: _propTypes2.default.bool,
  open: _propTypes2.default.bool,
  defaultOpen: _propTypes2.default.bool,
  placement: function placement() {
    return (typeof _TypeDefinition.bpfrpt_proptype_Placement === 'function' ? _TypeDefinition.bpfrpt_proptype_Placement : _propTypes2.default.shape(_TypeDefinition.bpfrpt_proptype_Placement)).apply(this, arguments);
  },
  style: _propTypes2.default.object
};

var _initialiseProps = function _initialiseProps() {
  var _this6 = this;

  this.getFocusableMenuItems = function () {
    var labelKey = _this6.props.labelKey;
    var menuItems = _this6.menuContainer.menuItems;

    if (!menuItems) {
      return [];
    }
    var items = Object.values(menuItems).map(function (item) {
      return item.props.getItemData();
    });

    return (0, _utils.filterNodesOfTree)(items, function (item) {
      return _this6.shouldDisplay(item[labelKey]);
    });
  };

  this.handleKeyDown = function (event) {
    if (!_this6.menuContainer) {
      return;
    }

    switch (event.keyCode) {
      // down
      case 40:
        _this6.focusNextMenuItem();
        event.preventDefault();
        break;
      // up
      case 38:
        _this6.focusPrevMenuItem();
        event.preventDefault();
        break;
      // enter
      case 13:
        _this6.selectFocusMenuItem(event);
        event.preventDefault();
        break;
      // esc | tab
      case 27:
      case 9:
        _this6.closeDropdown();
        event.preventDefault();
        break;
      default:
    }
  };

  this.handleItemSelect = function (nextItemValue, item, event, checked) {
    var value = _this6.getValue();

    if (checked) {
      value.push(nextItemValue);
    } else {
      (0, _remove3.default)(value, function (itemVal) {
        return (0, _utils.shallowEqual)(itemVal, nextItemValue);
      });
    }

    var nextState = {
      value: value,
      focusItemValue: nextItemValue
    };

    _this6.setState(nextState, function () {
      _this6.handleSelect(value, item, event);
      _this6.handleChangeValue(value, event);
    });
  };

  this.handleSelect = function (nextItemValue, item, event) {
    var onSelect = _this6.props.onSelect;

    onSelect && onSelect(nextItemValue, item, event);
  };

  this.handleChangeValue = function (value, event) {
    var onChange = _this6.props.onChange;

    onChange && onChange(value, event);
  };

  this.handleSearch = function (searchKeyword, event) {
    var onSearch = _this6.props.onSearch;

    _this6.setState({
      searchKeyword: searchKeyword,
      focusItemValue: undefined
    });
    onSearch && onSearch(searchKeyword, event);
  };

  this.closeDropdown = function () {
    var value = _this6.getValue();
    if (_this6.trigger) {
      _this6.trigger.hide();
    }
    _this6.setState({
      focusItemValue: value ? value[0] : undefined
    });
  };

  this.handleClean = function (event) {
    var disabled = _this6.props.disabled;

    if (disabled) {
      return;
    }
    _this6.setState({ value: [] }, function () {
      _this6.handleChangeValue([], event);
    });
  };

  this.handleExited = function () {
    var onClose = _this6.props.onClose;

    var value = _this6.getValue();
    onClose && onClose();
    _this6.setState({
      focusItemValue: value ? value[0] : undefined
    });
  };

  this.handleOpen = function () {
    var onOpen = _this6.props.onOpen;

    onOpen && onOpen();
  };

  this.addPrefix = function (name) {
    return (0, _utils2.prefix)(_this6.props.classPrefix)(name);
  };

  this.container = null;

  this.bindContainerRef = function (ref) {
    _this6.container = ref;
  };

  this.trigger = null;

  this.bindTriggerRef = function (ref) {
    _this6.trigger = ref;
  };

  this.menuContainer = {
    menuItems: null
  };

  this.bindMenuContainerRef = function (ref) {
    _this6.menuContainer = ref;
  };
};

var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});

exports.default = enhance(Dropdown);